<html>
<head>
<title>OgreResourceBackgroundQueue.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreResourceBackgroundQueue.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreResourceBackgroundQueue_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __ResourceBackgroundQueue_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __ResourceBackgroundQueue_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreResource_8h.html">OgreResource.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreWorkQueue_8h.html">OgreWorkQueue.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821">00047</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1WorkQueue.html#a1908257e726af6caa80f1a6cd5682d76" title="Numeric identifier for a request.">WorkQueue::RequestID</a> <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a>;
<a name="l00048"></a>00048 
<a name="l00050"></a><a class="code" href="structOgre_1_1BackgroundProcessResult.html">00050</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1BackgroundProcessResult.html" title="Encapsulates the result of a background queue request.">BackgroundProcessResult</a>
<a name="l00051"></a>00051     {
<a name="l00053"></a><a class="code" href="structOgre_1_1BackgroundProcessResult.html#aebcd24f1d14c77fcb242aa937658c7f2">00053</a>         <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1BackgroundProcessResult.html#aebcd24f1d14c77fcb242aa937658c7f2" title="Whether an error occurred.">error</a>;
<a name="l00055"></a><a class="code" href="structOgre_1_1BackgroundProcessResult.html#aa6de3c8fdaefa3b4a3895948fc9c115b">00055</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1BackgroundProcessResult.html#aa6de3c8fdaefa3b4a3895948fc9c115b" title="Any messages from the process.">message</a>;
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="structOgre_1_1BackgroundProcessResult.html#a934afcd6516ef003331f5423ec485f1e">00057</a>         <a class="code" href="structOgre_1_1BackgroundProcessResult.html#a934afcd6516ef003331f5423ec485f1e">BackgroundProcessResult</a>() : <a class="code" href="structOgre_1_1BackgroundProcessResult.html#aebcd24f1d14c77fcb242aa937658c7f2" title="Whether an error occurred.">error</a>(false) {}
<a name="l00058"></a>00058     };
<a name="l00059"></a>00059 
<a name="l00060"></a>00060     
<a name="l00080"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html">00080</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;ResourceBackgroundQueue&gt;, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ResourceAlloc</a>, 
<a name="l00081"></a>00081         <span class="keyword">public</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>::RequestHandler, <span class="keyword">public</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>::ResponseHandler
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083     <span class="keyword">public</span>:
<a name="l00092"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html">00092</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html" title="This abstract listener interface lets you get notifications of completed background processes instead...">Listener</a>
<a name="l00093"></a>00093         {
<a name="l00094"></a>00094         <span class="keyword">public</span>:
<a name="l00101"></a>00101             <span class="keyword">virtual</span> <span class="keywordtype">void</span> operationCompleted(<a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> ticket, <span class="keyword">const</span> <a class="code" href="structOgre_1_1BackgroundProcessResult.html" title="Encapsulates the result of a background queue request.">BackgroundProcessResult</a>&amp; result) = 0;
<a name="l00103"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html#a28509ef0c32ec32d3fa12a672ba90c2f">00103</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html#a28509ef0c32ec32d3fa12a672ba90c2f" title="Need virtual destructor in case subclasses use it.">~Listener</a>() {}
<a name="l00104"></a>00104 
<a name="l00105"></a>00105         };
<a name="l00106"></a>00106 
<a name="l00107"></a>00107     <span class="keyword">protected</span>:
<a name="l00108"></a>00108 
<a name="l00109"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#a6bfe913acebb812e67a5ccf669ac4b85">00109</a>         <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#a6bfe913acebb812e67a5ccf669ac4b85">mWorkQueueChannel</a>;
<a name="l00111"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#aedf467d04f827459c96ba08cdf61b745">00111</a>         <span class="keyword">enum</span> <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#aedf467d04f827459c96ba08cdf61b745" title="Enumerates the type of requests.">RequestType</a>
<a name="l00112"></a>00112         {
<a name="l00113"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#aedf467d04f827459c96ba08cdf61b745ae8ee38057ec65c7818091b1caca338ca">00113</a>             RT_INITIALISE_GROUP = 0,
<a name="l00114"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#aedf467d04f827459c96ba08cdf61b745a9a307a52ca7851def901b0140b727a3d">00114</a>             RT_INITIALISE_ALL_GROUPS = 1,
<a name="l00115"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#aedf467d04f827459c96ba08cdf61b745acf908f9b6fcb1de03a07bae3f8cd4e06">00115</a>             RT_PREPARE_GROUP = 2,
<a name="l00116"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#aedf467d04f827459c96ba08cdf61b745a665332bd3793442bba7ea49234396dc3">00116</a>             RT_PREPARE_RESOURCE = 3,
<a name="l00117"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#aedf467d04f827459c96ba08cdf61b745a6fc6a9ca84e7613ae861d7c432843cc9">00117</a>             RT_LOAD_GROUP = 4,
<a name="l00118"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#aedf467d04f827459c96ba08cdf61b745a7327f4cfe781534a62de7541b5f23e15">00118</a>             RT_LOAD_RESOURCE = 5,
<a name="l00119"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#aedf467d04f827459c96ba08cdf61b745a9d78e28a478d97ad7e7d0bbb03699fb5">00119</a>             RT_UNLOAD_GROUP = 6,
<a name="l00120"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#aedf467d04f827459c96ba08cdf61b745a471ed9d09791d8524d9f9b838cd2da72">00120</a>             RT_UNLOAD_RESOURCE = 7
<a name="l00121"></a>00121         };
<a name="l00123"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html">00123</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html" title="Encapsulates a queued request for the background queue.">ResourceRequest</a>
<a name="l00124"></a>00124         {
<a name="l00125"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a69799d5ebb705f6e8960de68b43a291c">00125</a>             <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#aedf467d04f827459c96ba08cdf61b745" title="Enumerates the type of requests.">RequestType</a> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a69799d5ebb705f6e8960de68b43a291c">type</a>;
<a name="l00126"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#af0f0bc6bbfdd8d0832545f560a031a01">00126</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#af0f0bc6bbfdd8d0832545f560a031a01">resourceName</a>;
<a name="l00127"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a5010830edc3d6fc7fe5cd3ab4b885f6a">00127</a>             <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a5010830edc3d6fc7fe5cd3ab4b885f6a">resourceHandle</a>;
<a name="l00128"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a7d4d06543328af3f1550fdea2ec2f0ac">00128</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a7d4d06543328af3f1550fdea2ec2f0ac">resourceType</a>;
<a name="l00129"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#ab094fe597690f96e2eb9e215715e9efa">00129</a>             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#ab094fe597690f96e2eb9e215715e9efa">groupName</a>;
<a name="l00130"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a8bf83ba68d9ed93b03e95b64ce76a551">00130</a>             <span class="keywordtype">bool</span> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a8bf83ba68d9ed93b03e95b64ce76a551">isManual</a>; 
<a name="l00131"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a62fd7de072fa064dd8e1edd5e2015de7">00131</a>             <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a62fd7de072fa064dd8e1edd5e2015de7">loader</a>;
<a name="l00132"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a093ecd7b9347cb30747a9894ccd64053">00132</a>             <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a093ecd7b9347cb30747a9894ccd64053">loadParams</a>;
<a name="l00133"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#ac6ac97360dd43c91ccef59d726f93e04">00133</a>             <a class="code" href="classOgre_1_1ResourceBackgroundQueue_1_1Listener.html" title="This abstract listener interface lets you get notifications of completed background processes instead...">Listener</a>* <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#ac6ac97360dd43c91ccef59d726f93e04">listener</a>;
<a name="l00134"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a3f4a164e5f83968645c65302a380d257">00134</a>             <a class="code" href="structOgre_1_1BackgroundProcessResult.html" title="Encapsulates the result of a background queue request.">BackgroundProcessResult</a> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a3f4a164e5f83968645c65302a380d257">result</a>;
<a name="l00135"></a>00135 
<a name="l00136"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html#a4f919d9838f97100888df85968456ae2">00136</a>             <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="group__General.html#ga6d67d46d838de3b38264f17fb792cddc">operator&lt;&lt;</a>(std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html" title="Encapsulates a queued request for the background queue.">ResourceRequest</a>&amp; r)
<a name="l00137"></a>00137             { (void)r; <span class="keywordflow">return</span> o; }
<a name="l00138"></a>00138         };
<a name="l00139"></a>00139 
<a name="l00140"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#a312aade4d2413f1de1ef3181cabe457f">00140</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;BackgroundProcessTicket&gt;::type</a> <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#a312aade4d2413f1de1ef3181cabe457f">OutstandingRequestSet</a>;   
<a name="l00141"></a><a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#abd1a89bbcf6f99825db901c3e382b14f">00141</a>         <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#a312aade4d2413f1de1ef3181cabe457f">OutstandingRequestSet</a> <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html#abd1a89bbcf6f99825db901c3e382b14f">mOutstandingRequestSet</a>;
<a name="l00142"></a>00142 
<a name="l00144"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceResponse.html">00144</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceResponse.html" title="Struct that holds details of queued notifications.">ResourceResponse</a>
<a name="l00145"></a>00145         {
<a name="l00146"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceResponse.html#a273f0c5b3275ddd6166ba2ef76888c15">00146</a>             <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceResponse.html" title="Struct that holds details of queued notifications.">ResourceResponse</a>(<a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a> r, <span class="keyword">const</span> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html" title="Encapsulates a queued request for the background queue.">ResourceRequest</a>&amp; req)
<a name="l00147"></a>00147                 : resource(r), request(req)
<a name="l00148"></a>00148             {}
<a name="l00149"></a>00149 
<a name="l00150"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceResponse.html#a4718ced699bc2d2105c04044db17e8ee">00150</a>             <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceResponse.html#a4718ced699bc2d2105c04044db17e8ee">resource</a>;
<a name="l00151"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceResponse.html#a2fe25475ea2db06e0ec8382d876d46c2">00151</a>             <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceRequest.html" title="Encapsulates a queued request for the background queue.">ResourceRequest</a> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceResponse.html#a2fe25475ea2db06e0ec8382d876d46c2">request</a>;
<a name="l00152"></a>00152 
<a name="l00153"></a><a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceResponse.html#a99ed1dd62bfaafa97c80fea4c7e349b7">00153</a>             <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="group__General.html#ga6d67d46d838de3b38264f17fb792cddc">operator&lt;&lt;</a>(std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="structOgre_1_1ResourceBackgroundQueue_1_1ResourceResponse.html" title="Struct that holds details of queued notifications.">ResourceResponse</a>&amp; r)
<a name="l00154"></a>00154             { (void)r; <span class="keywordflow">return</span> o; }
<a name="l00155"></a>00155         };
<a name="l00156"></a>00156 
<a name="l00157"></a>00157         <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> addRequest(ResourceRequest&amp; req);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159     <span class="keyword">public</span>:
<a name="l00160"></a>00160         <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a>();
<a name="l00161"></a>00161         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a>();
<a name="l00162"></a>00162 
<a name="l00166"></a>00166         <span class="keyword">virtual</span> <span class="keywordtype">void</span> initialise(<span class="keywordtype">void</span>);
<a name="l00167"></a>00167 
<a name="l00171"></a>00171         <span class="keyword">virtual</span> <span class="keywordtype">void</span> shutdown(<span class="keywordtype">void</span>);
<a name="l00172"></a>00172 
<a name="l00181"></a>00181         <span class="keyword">virtual</span> <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> initialiseResourceGroup(
<a name="l00182"></a>00182             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, Listener* listener = 0);
<a name="l00183"></a>00183 
<a name="l00192"></a>00192         <span class="keyword">virtual</span> <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> initialiseAllResourceGroups( 
<a name="l00193"></a>00193             Listener* listener = 0);
<a name="l00202"></a>00202         <span class="keyword">virtual</span> <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> prepareResourceGroup(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00203"></a>00203             Listener* listener = 0);
<a name="l00204"></a>00204 
<a name="l00213"></a>00213         <span class="keyword">virtual</span> <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> loadResourceGroup(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00214"></a>00214             Listener* listener = 0);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00223"></a>00223         <span class="keyword">virtual</span> <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> unload(
<a name="l00224"></a>00224             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resType, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00225"></a>00225             Listener* listener = 0);
<a name="l00226"></a>00226 
<a name="l00233"></a>00233         <span class="keyword">virtual</span> <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> unload(
<a name="l00234"></a>00234             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resType, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle, 
<a name="l00235"></a>00235             Listener* listener = 0);
<a name="l00236"></a>00236 
<a name="l00243"></a>00243         <span class="keyword">virtual</span> <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> unloadResourceGroup(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00244"></a>00244             Listener* listener = 0);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00262"></a>00262         <span class="keyword">virtual</span> <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> prepare(
<a name="l00263"></a>00263             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resType, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00264"></a>00264             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, 
<a name="l00265"></a>00265             <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0, 
<a name="l00266"></a>00266             <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* loadParams = 0, 
<a name="l00267"></a>00267             Listener* listener = 0);
<a name="l00268"></a>00268 
<a name="l00284"></a>00284         <span class="keyword">virtual</span> <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> load(
<a name="l00285"></a>00285             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; resType, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, 
<a name="l00286"></a>00286             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, 
<a name="l00287"></a>00287             <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0, 
<a name="l00288"></a>00288             <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* loadParams = 0, 
<a name="l00289"></a>00289             Listener* listener = 0);
<a name="l00303"></a>00303         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isProcessComplete(<a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> ticket);
<a name="l00304"></a>00304 
<a name="l00307"></a>00307         <span class="keywordtype">void</span> abortRequest( <a class="code" href="group__Resources.html#ga1e2e9ee3e2ee22a4e792952239d38821" title="Identifier of a background process.">BackgroundProcessTicket</a> ticket );
<a name="l00308"></a>00308 
<a name="l00310"></a>00310         <span class="keywordtype">bool</span> canHandleRequest(<span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">WorkQueue::Request</a>* req, <span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>* srcQ);
<a name="l00312"></a>00312         <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">WorkQueue::Response</a>* handleRequest(<span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue_1_1Request.html" title="General purpose request structure.">WorkQueue::Request</a>* req, <span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>* srcQ);
<a name="l00314"></a>00314         <span class="keywordtype">bool</span> canHandleResponse(<span class="keyword">const</span> <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">WorkQueue::Response</a>* res, <span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>* srcQ);
<a name="l00316"></a>00316         <span class="keywordtype">void</span> handleResponse(<span class="keyword">const</span> <a class="code" href="structOgre_1_1WorkQueue_1_1Response.html" title="General purpose response structure.">WorkQueue::Response</a>* res, <span class="keyword">const</span> <a class="code" href="classOgre_1_1WorkQueue.html" title="Interface to a general purpose request / response style background work queue.">WorkQueue</a>* srcQ);
<a name="l00317"></a>00317 
<a name="l00333"></a>00333         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a>&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00349"></a>00349         <span class="keyword">static</span> <a class="code" href="classOgre_1_1ResourceBackgroundQueue.html" title="This class is used to perform Resource operations in a background thread.">ResourceBackgroundQueue</a>* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00350"></a>00350 
<a name="l00351"></a>00351     };
<a name="l00352"></a>00352 
<a name="l00356"></a>00356 }
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 <span class="preprocessor">#endif</span>
<a name="l00359"></a>00359 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
